#include "bmisc.h"

point Blnd_CubeMap(point in)
{
  extern normal N;
  normal nor = ntransform("world", "camera", N);
  float x = xcomp(in);
  float y = ycomp(in);
  float z = zcomp(in);
  float x1 = abs(xcomp(nor));
  float y1 = abs(ycomp(nor));
  float z1 = abs(zcomp(nor));
  point out;

  if (z1 >= x1 && z1 >= y1) {
	out = point((x + 1) / 2, (y + 1) / 2, 0);
  } else if (y1 >= x1 && y1 >= z1) {
	out = point((x + 1) / 2, (z + 1) / 2, 0);
  } else {
	out = point((y + 1) / 2, (z + 1) / 2, 0);
  }

  return out;
}

point Blnd_SphereMap(point in)
{
  point out;
  float len = length(vector in);

  if (len > 0) {
	if (xcomp(in) == 0 && ycomp(in) == 0) {
	  setxcomp(out, 0);
	} else {
	  setxcomp(out, (1 - atan(xcomp(in), ycomp(in)) / PI) / 2);
	}

	setycomp(out, 1 - saacos(zcomp(in) / len) / PI);
  }

  return out;
}

point Blnd_TubeMap(point in)
{
  float len = length(vector(xcomp(in), ycomp(in), 0));
  point out = (0, (zcomp(in) + 1) / 2, 0);
  if (len > 0) {
	setxcomp(out, (1 - atan(xcomp(in) / len, ycomp(in) / len) / PI) / 2);
  }
  return out;
}
