/*
	Blender waveforms
*/

float Blnd_WaveSin(float a)
{
  return 0.5 + 0.5*sin(a);
}

float Blnd_WaveSaw(float a)
{
  uniform float b = radians(360);
  float n = floor(a / b);
  float a_ = a;
  a_ -= n*b;
  if (a_ < 0)
    a_ += b;
  return a_/b;
}

float Blnd_WaveTri(float a)
{
  uniform float b = radians(360);
  uniform float rmax = 1.0;
  return rmax - 2*abs(floor((a*(1.0/b))+0.5) - (a*(1.0/b)));
}

float Blnd_Waveform(string wavetype; float a)
{
  float f;

  if (wavetype == "sin")
      f = Blnd_WaveSin(a);
  else if (wavetype == "saw")
      f = Blnd_WaveSaw(a);
  else if (wavetype == "tri")
      f = Blnd_WaveTri(a);

  return f;
}
