# Blender image->Renderman exporter
# Version 0.1

import os
import Blender
from Blender import Texture, Image, Draw

renderers = [ 'aqsis', 'pixie', '3delight', 'bmrt' ]
texers = { 'aqsis':'teqser', 'pixie':'texmake', '3delight':'tdlmake', 'bmrt':'mkmip' }
outSuffixes = { 'aqsis':'.tiff', 'pixie':'.tiff', '3delight':'.tiff', 'bmrt':'.tiff' }

# Use yafray dir for export
outPath = Blender.Get('yfexportdir')

rendMenu = 'Process for what renderer?%t'
for i in range(len(renderers)):
	rendMenu += '|%s%%x%d' % (renderers[i], i)
n = Draw.PupMenu(rendMenu)
if n == -1: n = 0
rend = renderers[n]

# Find texer!
path = os.getenv('PATH')
for pathDir in path.split(':'):
	texer = os.path.join(pathDir, texers[rend])
	if os.path.exists(texer):
		break

process = 1

texs = Texture.Get()
for tex in texs:
	if tex.getType() != "Image":
		continue

	img = tex.image

	if img == None:
		continue

	if process != 3:
		process = Draw.PupMenu(
			"Process '%s'?%%t|Yes|No|Yes from now on|No from now on" % img.name, 1)
		if process == 2:
			continue
		if process == 4:
			break;

	inp = img.filename
	out = os.path.join(outPath, tex.name + outSuffixes[rend])

	ret = os.spawnv(os.P_WAIT, texer, (texer, inp, out))
	# Do something with the return value!
	#print ret
