import wx, wx.xrc, os, pickle, zlib
import pixie,aqsis,delight
import sManClass

## Global Vars ##
globalError = ""
class Scene:
    def __call__(self):
        self = self
    def __name__(self):
        self = self
    def __dict__(self):
        pass
    material = []
    pass
class Lamp:
    pass
class Camera:
    pass
class Mesh:
    pass
class Curve:
    pass
class geometry: pass
osType      = os.name
try:
    pixiePath   = os.environ.get("PIXIEHOME")
    aqsisPath   = os.environ.get("AQSISHOME")
    delightPath = os.environ.get("DELIGHT")
except: print "Error with renderman Paths"
## Rendermans render path error
shaders     = os.listdir(pixiePath+"//shaders//")
surfaceIndex    = []
displaceIndex   = []
lightIndex      =[]
treeItem    = None
treeParent = None
lightItems = None

def searchMesh(name):
    for mesh in Scene.meshes:
        if mesh.name == name:
            return mesh
def searchScene(name, type):
    for item in eval("Scene."+type):
        if item.name == name:
            return item
 
### Convert Array into outputtable strings -Fast!
def arrayOut(arr):
    out = str(arr)
    for xout in (",", "[", "]"):
        out = out.replace(xout, "")
    return "["+out+"]"
def readImage(iFile):
        import Image 
        source = Image.open( iFile, 'r') 
        image = apply( wx.EmptyImage, source.size ) 
        image.SetData( source.convert( "RGB").tostring() ) 
        return wx.BitmapFromImage(image)
class cName:
    def __init__(self):
        self.name = ""    
class surfaceShader:
    def __init__(self):
        self.name = ""
class displaceShader:
    def __init__(self):
        self.name = ""
class lightShader:
    def __init__(self):
        self.name = ""
class surfaceMat:
    def __init__(self):
        name        = ""
        self.surf   = None
        self.disp   = None
        self.color  = None

class MyApp(wx.App):
    def OnInit(self):
        self.res = wx.xrc.XmlResource("BMan.xrc")
        self.InitFrame()
        return True

    def InitFrame(self):
        self.frame      = self.res.LoadFrame(None, "mainFrame")
        self.panel      = wx.xrc.XRCCTRL(self.frame, "mainPanel")
        self.notebook   = wx.xrc.XRCCTRL(self.panel, "mainNotebook")
        self.gPanel     = wx.xrc.XRCCTRL(self.notebook, "Global")
        self.sPanel     = wx.xrc.XRCCTRL(self.notebook, "Scene")
        self.shadePanel = wx.xrc.XRCCTRL(self.notebook, "Shader")
        self.oPanel     = wx.xrc.XRCCTRL(self.notebook, "Object")
        #self.menu       = wx.xrc.XRCCTRL(self.frame, "Menu")


        ####################### Debug ###########################
        self.debug          = wx.xrc.XRCCTRL(self.frame, "debugger")
        self.debug.AppendText(globalError)
        #########################################################
        ####################### Menu ###########################
        self.new            = wx.xrc.XRCCTRL(self.frame, "new")
        self.open           = wx.xrc.XRCCTRL(self.frame, "open")
        self.save           = wx.xrc.XRCCTRL(self.frame, "save")
        #self.load           = wx.xrc.XRCCTRL(self.frame, "load")
        #self.help           = wx.xrc.XRCCTRL(self.frame, "help")
        self.about          = wx.xrc.XRCCTRL(self.frame, "about")
        ## -Events
        wx.EVT_BUTTON(self, wx.xrc.XRCID("save"), self.newsMan)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("save"), self.savesMan)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("load"), self.loadBlendFile)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("about"), self.aboutSoftware)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("open"), self.loadsMan)
        
        ########################################################
        
        ####################### Global Panel ###########################
        self.rendermanExe   = wx.xrc.XRCCTRL(self.gPanel, "rendermanExe")
        self.textureExe     = wx.xrc.XRCCTRL(self.gPanel, "textureExe")
        self.folderName     = wx.xrc.XRCCTRL(self.gPanel, "folderName")
        self.imageName      = wx.xrc.XRCCTRL(self.gPanel, "imageName")
        self.ribName        = wx.xrc.XRCCTRL(self.gPanel, "ribName")

        self.rendermanType  = wx.xrc.XRCCTRL(self.gPanel, "rendermanType")
        self.envName        = wx.xrc.XRCCTRL(self.gPanel, "envName")
        self.renderType     = wx.xrc.XRCCTRL(self.gPanel, "renderType")
        self.sRate          = wx.xrc.XRCCTRL(self.gPanel, "sRate")
        self.samples        = wx.xrc.XRCCTRL(self.gPanel, "samples")
        self.debugTxt       = wx.xrc.XRCCTRL(self.gPanel, "debugTxt")
        self.debugLevel     = wx.xrc.XRCCTRL(self.gPanel, "debugLevel")
        self.rayTxt         = wx.xrc.XRCCTRL(self.gPanel, "rayTxt")
        self.raySteps       = wx.xrc.XRCCTRL(self.gPanel, "raySteps")

        self.toggleFile     = wx.xrc.XRCCTRL(self.gPanel, "toggleFile")
        self.toggleBuffer   = wx.xrc.XRCCTRL(self.gPanel, "toggleBuffer")
        self.toggleAnimation= wx.xrc.XRCCTRL(self.gPanel, "toggleAnimation")
        self.toggleRender   = wx.xrc.XRCCTRL(self.gPanel, "toggleRender")
        self.export         = wx.xrc.XRCCTRL(self.gPanel, "export")
        self.rezX           = wx.xrc.XRCCTRL(self.gPanel, "rezX")
        self.rezY           = wx.xrc.XRCCTRL(self.gPanel, "rezY")
        self.setRezButton   = wx.xrc.XRCCTRL(self.gPanel, "setRezButton")
        ## -Init
        ## -Events
        wx.EVT_COMBOBOX(self, wx.xrc.XRCID("samples"), self.setSamples)
        wx.EVT_COMBOBOX(self, wx.xrc.XRCID("rendermanType"), self.setRendermanType)
        wx.EVT_COMBOBOX(self, wx.xrc.XRCID("sRate"), self.setShaderRate)
        wx.EVT_CHECKBOX(self, wx.xrc.XRCID("toggleFile"), self.toggleFileOutput)
        wx.EVT_CHECKBOX(self, wx.xrc.XRCID("toggleBuffer"), self.toggleBufferOutput)
        wx.EVT_SLIDER(self, wx.xrc.XRCID("debugLevel"), self.debugSlider)
        wx.EVT_SLIDER(self, wx.xrc.XRCID("raySteps"), self.raySlider)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("hider"), self.hiderButton)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("export"), self.exportRib)
        wx.EVT_TEXT_ENTER(self,wx.xrc.XRCID("rezX"), self.getREZ)
        wx.EVT_TEXT_ENTER(self,wx.xrc.XRCID("rezY"), self.getREZ)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("setRezButton"), self.getREZ)
        ##################################################################

        ######################### Scene Panel ############################
        self.occlusion      = wx.xrc.XRCCTRL(self.sPanel, "occlusion")
        self.indirect       = wx.xrc.XRCCTRL(self.sPanel, "indirect")
        self.giSamples      = wx.xrc.XRCCTRL(self.sPanel, "giSamples")

        self.mBlur          = wx.xrc.XRCCTRL(self.sPanel, "mBlur")
        self.blurFrames     = wx.xrc.XRCCTRL(self.sPanel, "blurFrames")
        self.blurFrameText  = wx.xrc.XRCCTRL(self.sPanel, "blurFrameText")

        self.DOFpanel       = wx.xrc.XRCCTRL(self.sPanel, "DOFpanel")
        self.DOF            = wx.xrc.XRCCTRL(self.sPanel, "DOFtoggle")
        self.dofStop        = wx.xrc.XRCCTRL(self.sPanel, "dofStop")
        self.dofLength      = wx.xrc.XRCCTRL(self.sPanel, "dofLength")
        self.dofDist        = wx.xrc.XRCCTRL(self.sPanel, "dofDist")
        ## -Init
        for child in self.DOFpanel.GetChildren():
            childType = str(type(child))
            if childType.find('StaticText') >= 0 or childType.find('TextCtrl') >= 0:
                child.Hide()
        ## -Events
        wx.EVT_SLIDER(self, wx.xrc.XRCID("blurFrames"), self.blurSlider)
        wx.EVT_CHECKBOX(self, wx.xrc.XRCID("DOFtoggle"), self.toggleDOF)
        
        ##################################################################

        ######################### Shader Panel ############################
        self.surfaces       = wx.xrc.XRCCTRL(self.shadePanel, "surfaces")
        self.addSurface     = wx.xrc.XRCCTRL(self.shadePanel, "addSurface")
        self.surfaceTxt     = wx.xrc.XRCCTRL(self.shadePanel, "surfaceTxt")
        self.surfaceList    = wx.xrc.XRCCTRL(self.shadePanel, "surfaceList")
        self.reloadSurfaces = wx.xrc.XRCCTRL(self.shadePanel, "reloadSurfaces")
        self.editSurface    = wx.xrc.XRCCTRL(self.shadePanel, "editSurface")
        self.dispTxt        = wx.xrc.XRCCTRL(self.shadePanel, "dispTxt")
        self.dispList       = wx.xrc.XRCCTRL(self.shadePanel, "dispList")
        self.reloadDisp     = wx.xrc.XRCCTRL(self.shadePanel, "reloadDisp")
        self.editDisplace   = wx.xrc.XRCCTRL(self.shadePanel, "editDisplace")
        self.paraTxt        = wx.xrc.XRCCTRL(self.shadePanel, "paraTxt")
        self.bTestRender    = wx.xrc.XRCCTRL(self.shadePanel, "bTestRender")
        self.testImage      = wx.xrc.XRCCTRL(self.shadePanel, "testImage")
        self.parametersPanel= wx.xrc.XRCCTRL(self.shadePanel, "parametersPanel")
        self.paraPanelSizer = self.parametersPanel.GetSizer()

        ## -Init
        self.surfaceTxt.Hide()
        self.surfaceList.Hide()
        self.reloadSurfaces.Hide()
        self.editSurface.Hide()
        self.dispTxt.Hide()
        self.dispList.Hide()
        self.editDisplace.Hide()
        self.reloadDisp.Hide()
        #self.redrawParaPanel()
        ## -Events
        wx.EVT_COMBOBOX(self, wx.xrc.XRCID("surfaceList"), self.editParaOptions)
        wx.EVT_COMBOBOX(self, wx.xrc.XRCID("dispList"), self.editDispOptions)
        wx.EVT_COMBOBOX(self, wx.xrc.XRCID("surfaces"), self.setSurfOptions)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("addSurface"), self.createSurface)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("removeSurface"), self.deleteSurface)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("reloadSurfaces"), self.loadSurfaces)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("editSurface"), self.editParaOptions)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("reloadDisp"), self.loadDisp)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("reloadSurfaces"), self.loadSurfaces) 
        wx.EVT_BUTTON(self, wx.xrc.XRCID("editDisplace"), self.editDispOptions)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("bTestRender"), self.testRender)
        ###################################################################

        ######################### Object Panel ############################
        self.objTree            = wx.xrc.XRCCTRL(self.oPanel, "objTree")
        self.oEditPanel         = wx.xrc.XRCCTRL(self.oPanel, "oEditPanel")
        self.removeObjectButton = wx.xrc.XRCCTRL(self.oPanel, "removeObjectButton")

        ## -Init
        self.treeRoot = self.objTree.AddRoot("Scene")
        self.treeLight = self.objTree.AppendItem(self.treeRoot, "Lights")
        self.treeMesh = self.objTree.AppendItem(self.treeRoot, "Meshes")
        self.treeNurb = self.objTree.AppendItem(self.treeRoot, "Nurbs")
        self.treeCurve = self.objTree.AppendItem(self.treeRoot, "Curves")
        ## -Events
        wx.EVT_TREE_SEL_CHANGED(self, wx.xrc.XRCID("objTree"), self.redrawObjPanel)
        wx.EVT_BUTTON(self, wx.xrc.XRCID("removeObjectButton"), self.removeObject)
        ###################################################################
        
        self.frame.Show(True)
        self.SetTopWindow(self.frame)
        
## Refereneced Fucntions ##
    def readSL(self,file):
        shader = None
        if self.rendermanType.GetValue() == "Pixie":
            shader = pixie.readSL(file)
        elif self.rendermanType.GetValue() == "Aqsis":
            shader = aqsis.readSL(file)
        elif self.rendermanType.GetValue() == "3Delight":
            shader = delight.readSL(file)
        try:
            if shader.type == "surface":
                surfaceIndex.append(shader)
            if shader.type == "displacement":
                displaceIndex.append(shader)
            if shader.type == "light" or shader.type == "lightsource":
                lightIndex.append(shader)
        except AttributeError: pass
    def appendSL(self):
        if self.rendermanType.GetValue() == "Pixie":
            pixiePath = os.environ.get(self.envName.GetValue())
            shaders = os.listdir(pixiePath+"//shaders//")
            for s in shaders:
                if s.find(".sdr") >= 0:
                    shader = open(pixiePath+"//shaders//"+s)
                    self.readSL(shader)
        if self.rendermanType.GetValue() == "Aqsis":
            aqsisPath = os.environ.get(self.envName.GetValue())
            shaders = os.listdir(aqsisPath+"//shaders//")
            for s in shaders:
                if s.find(".slx") >= 0:
                    shader = open(aqsisPath+"//shaders//"+s)
                    self.readSL(shader)
        if self.rendermanType.GetValue() == "3Delight":
            delightPath = os.environ.get(self.envName.GetValue())
            shaders = os.listdir(delightPath+"//shaders//")
            for s in shaders:
                if s.find(".sdl") >= 0:
                    #shader = s[:-4]
                    shader = open(delightPath+"//shaders//"+s)
                    self.readSL(shader)
        for surface in surfaceIndex:
            self.surfaceList.Append(surface.name)
            self.surfaceList.Enable()
        for displace in displaceIndex:
            self.dispList.Append(displace.name)
            self.dispList.Enable()
        try:
            for light in Scene.lights:
                self.lightLinkChoice.Append(light.name)
        except: pass
    def parseSL(self,name):
         if self.rendermanType.GetValue() == "3Delight":
            delightPath = os.environ.get(self.envName.GetValue())
            shaders = os.listdir(delightPath+"//shaders//")
            file = delightPath+"//shaders//%s.sdl"%name
            return delight.gatherSlData(file)
         if self.rendermanType.GetValue() == "Pixie":
            pixiePath = os.environ.get(self.envName.GetValue())
            shaders = os.listdir(pixiePath+"//shaders//")
            file = pixiePath+"//shaders//%s.sdl"%name
            return pixie.gatherSlData(file)
         if self.rendermanType.GetValue() == "Aqsis":
            aqsisPath = os.environ.get(self.envName.GetValue())
            shaders = os.listdir(aqsisPath+"//shaders//")
            file = aqsisPath+"//shaders//%s.slx"%name
            return aqsis.gatherSlData(name)
## Global Panel Defs ##
    def setRendermanType(self,event):
        if self.rendermanType.GetValue() == "Aqsis":
            self.rendermanExe.SetValue("aqsis")
            self.textureExe.SetValue("teqser")
            self.envName.SetValue("AQSISHOME")
            Scene.renderman = "Aqsis"
        if self.rendermanType.GetValue() == "Pixie":
            self.rendermanExe.SetValue("rndr")
            self.textureExe.SetValue("texmake")
            self.envName.SetValue("PIXIEHOME")
            Scene.renderman = "Pixie"
        if self.rendermanType.GetValue() == "3Delight":
            self.rendermanExe.SetValue("renderdl")
            self.textureExe.SetValue("tdlmake")
            self.envName.SetValue("DELIGHT")
            Scene.renderman = "3Delight"
    def getREZ(self,event):
        Scene.resolution = [self.rezX.GetValue(),self.rezY.GetValue()]
    def setSamples(self,event):
        Scene.pixelSamples = self.samples.GetValue()
    def setShaderRate(self,event):
        Scene.pixelSamples = self.sRate.GetValue()
    def toggleFileOutput(self, event):
        #self.toggleBuffer.SetValue(False)
        Scene.output = "file"
    def toggleBufferOutput(self, event):
        #self.toggleFile.SetValue(False)
        Scene.output = "framebuffer"
    def debugSlider(self,event):
        val = str(self.debugLevel.GetValue())
        self.debugTxt.SetLabel("Debug Level "+val)
    def raySlider(self,event):
        val = str(self.raySteps.GetValue())
        self.rayTxt.SetLabel("Ray Steps "+val)
    def hiderButton(self,event):
        if Scene.renderman == "Pixie":
            hider = pixie.hider(self.frame)
            if hider.dlg.ShowModal() == wx.ID_OK:
                Scene.hider = hider.getAttributes()
## Scene Functions
    def toggleDOF(self,event):
        if self.DOF.GetValue():
            for child in self.DOFpanel.GetChildren():
                childType = str(type(child))
                if childType.find('StaticText') >= 0 or childType.find('TextCtrl') >= 0:
                    child.Show()
            self.DOFpanel.GetSizer().Fit(self.DOFpanel)
            self.notebook.Fit()
        else:
            for child in self.DOFpanel.GetChildren():
                childType = str(type(child))
                if childType.find('StaticText') >= 0 or childType.find('TextCtrl') >= 0:
                    child.Hide()
            self.DOFpanel.GetSizer().Fit(self.DOFpanel)
            self.notebook.Fit()
    def blurSlider(self,event):
        val = str(self.blurFrames.GetValue())
        self.blurFrameText.SetLabel("Frames "+val)
## Shader Editor
    def createSurface(self,event):
        if self.surfaces.GetValue():
            repeat = False
            for string in self.surfaces.GetStrings():
                if string == self.surfaces.GetValue():
                    repeat = True
            if repeat == False:
                Scene.material.append(surfaceMat())
                Scene.material[-1].name = self.surfaces.GetValue()
                self.surfaces.Append(self.surfaces.GetValue())
                self.showSurface()
    def showSurface(self):
        self.surfaceTxt.Show()
        self.surfaceList.Show()
        self.reloadSurfaces.Show()
        self.editSurface.Show()
        self.dispTxt.Show()
        self.dispList.Show()
        self.editDisplace.Show()
        self.reloadDisp.Show()
        self.shadePanel.GetSizer().Fit(self.shadePanel)
    def hideSurface(self):
        self.surfaceTxt.Hide()
        self.surfaceList.Hide()
        self.reloadSurfaces.Hide()
        self.editSurface.Hide()
        self.dispTxt.Hide()
        self.dispList.Hide()
        self.editDisplace.Hide()
        self.reloadDisp.Hide()
        self.shadePanel.GetSizer().Fit(self.shadePanel)
    def deleteSurface(self,event):
        for i,mat in enumerate(Scene.material):
            if mat.name == self.surfaces.GetValue():
                self.surfaces.Delete(i)
                self.surfaces.SetValue("")
                self.surfaceList.SetValue("")
                Scene.material.remove(mat)
                #clean panel here
                ## Need a new way to clean panel
                #self.redrawParaPanel()
                if len(Scene.material) == 0:
                    self.hideSurface()
    def loadSurfaces(self,event):
        global surfaceIndex
        self.surfaceList.Clear()
        surfaceIndex= []
        self.appendSL() 
    def loadDisp(self,event):
        global displaceIndex
        self.dispList.Clear()
        displaceIndex= []
        
        self.appendSL()
        
        for displace in displaceIndex:
            self.dispList.Append(displace.name)
            self.dispList.Enable()
    def setSurfOptions(self,event):
        if self.surfaces.GetValue():
            for mat in Scene.material:
                if self.surfaces.GetValue() == mat.name:
                    try:
                        self.surfaceList.SetValue(mat.surf.name)
                        self.redrawParaPanel()
                    except AttributeError: pass
    def editParaOptions(self,event):
        sVal = self.surfaceList.GetValue()
        
        
        self.parametersPanel.DestroyChildren()
        
        #Add Defaults to panel
        self.paraScrollPanel = sManClass.scrollPanel(self.parametersPanel)
        vbox = self.paraScrollPanel.GetSizer()
        self.colorPanel = self.res.LoadPanel(self.paraScrollPanel, "color")
        
        wx.EVT_BUTTON(self, wx.xrc.XRCID("colorButton"), self.colorDlg)
        
        self.paraTxt = wx.StaticText(self.paraScrollPanel, -1, "Parameters for "+sVal)
        vbox.Add(self.colorPanel, 0,wx.GROW)
        vbox.Add(self.paraTxt, 0,wx.GROW)
        
        #Add values to panel
        for mat in Scene.material:
            if self.surfaces.GetValue() == mat.name:
                if mat.surf and self.surfaceList.GetValue() == mat.surf.name:
                    shader = mat.surf
                else: shader = self.parseSL(sVal)
                mat.surf = shader
        for val in dir(shader):
            if val.find("_") and val.find("name") and val.find("type"):
                    self.valSizer = wx.BoxSizer(wx.HORIZONTAL)
                    label = wx.StaticText(self.paraScrollPanel, -1, val[4:])
                    txtCtrl = wx.TextCtrl(self.paraScrollPanel, -1, str(eval("shader."+val)))
                    self.valSizer.Add(label)
                    self.valSizer.Add(txtCtrl)
                    vbox.Add(self.valSizer)
        setButton = wx.Button(self.paraScrollPanel, -1, "Set")
        vbox.Add(setButton)
        self.paraScrollPanel.Bind(wx.EVT_BUTTON, self.setParasurf, setButton)
        self.paraScrollPanel.SetAutoLayout(1)
        self.paraScrollPanel.SetupScrolling()
        self.parametersPanel.GetSizer().Add(self.paraScrollPanel)
        self.shadePanel.GetSizer().Fit(self.shadePanel)
        self.notebook.Fit()
    def editDispOptions(self,event):
        sVal = self.dispList.GetValue()
        
        
        self.parametersPanel.DestroyChildren()
        
        #Add Defaults to panel
        self.paraScrollPanel = sManClass.scrollPanel(self.parametersPanel)
        vbox = self.paraScrollPanel.GetSizer()
        self.colorPanel = self.res.LoadPanel(self.paraScrollPanel, "color")
        
        wx.EVT_BUTTON(self, wx.xrc.XRCID("colorButton"), self.colorDlg)
        
        self.paraTxt = wx.StaticText(self.paraScrollPanel, -1, "Parameters for "+sVal)
        vbox.Add(self.colorPanel, 0,wx.GROW)
        vbox.Add(self.paraTxt, 0,wx.GROW)
        
        #Add values to panel
        for mat in Scene.material:
            if self.surfaces.GetValue() == mat.name:
                if mat.disp and self.dispList.GetValue() == mat.disp.name:
                    shader = mat.disp
                else: shader = self.parseSL(sVal)
                mat.disp = shader
        for val in dir(shader):
            if val.find("_") and val.find("name") and val.find("type"):
                    self.valSizer = wx.BoxSizer(wx.HORIZONTAL)
                    label = wx.StaticText(self.paraScrollPanel, -1, val[4:])
                    txtCtrl = wx.TextCtrl(self.paraScrollPanel, -1, str(eval("shader."+val)))
                    self.valSizer.Add(label)
                    self.valSizer.Add(txtCtrl)
                    vbox.Add(self.valSizer)
        setButton = wx.Button(self.paraScrollPanel, -1, "Set")
        vbox.Add(setButton)
        self.paraScrollPanel.Bind(wx.EVT_BUTTON, self.setParasurf, setButton)
        self.paraScrollPanel.SetAutoLayout(1)
        self.paraScrollPanel.SetupScrolling()
        self.parametersPanel.GetSizer().Add(self.paraScrollPanel)
        self.shadePanel.GetSizer().Fit(self.shadePanel)
        self.notebook.Fit()
        self.notebook.Fit()
    def setParasurf(self,event):
        self.getVals()
    def getVals(self):
        scrollPanel = self.parametersPanel.GetChildren()[0].GetChildren()
        for i,child in enumerate(scrollPanel):
            if child.GetName() == "staticText":
                if child.GetLabel().find("Parameters") == -1:
                    for mat in Scene.material:
                        if self.surfaces.GetValue() == mat.name:
                            for val in dir(mat.surf):
                                if val.find("_") and val.find("name") and val.find("type"):
                                        if scrollPanel[i+1].GetValue():
                                            try:
                                                #print child.GetLabel(),eval('mat.surf.%s'%'para'+child.GetLabel())
                                                if str(type(eval('mat.surf.'+'para'+child.GetLabel()))).find("str") >= 0:
                                                    exec('mat.surf.%s = "%s"'%('para'+child.GetLabel(), scrollPanel[i+1].GetValue()))
                                                else:
                                                    exec('mat.surf.%s = %f'%('para'+child.GetLabel(), float(scrollPanel[i+1].GetValue())))
                                            except: pass
                            for val in dir(mat.disp):
                                if val.find("_") and val.find("name") and val.find("type"):
                                    if scrollPanel[i+1].GetValue():
                                        try:
                                            if str(type(eval('mat.disp.'+'para'+child.GetLabel()))).find("str") >= 0:
                                                exec('mat.disp.%s = "%s"'%('para'+child.GetLabel(), scrollPanel[i+1].GetValue()))
                                            else:
                                                exec('mat.disp.%s = %f'%('para'+child.GetLabel(), float(scrollPanel[i+1].GetValue())))
                                        except: pass         

    def colorDlg(self,event):
        dlg = wx.ColourDialog(self.colorPanel)
        dlg.GetColourData().SetChooseFull(True)
        if dlg.ShowModal() == wx.ID_OK:
            data = dlg.GetColourData()
            for mat in Scene.material:
                if self.surfaces.GetValue() == mat.name:
                    mat.color = data.GetColour().Get()
                    self.colorPanel.GetChildren()[1].SetValue(str(mat.color))
                        
        dlg.Destroy()
    def testRender(self,event):
        self.debug.AppendText("xPorting to test rib\n")
        self.getVals()
        #self.getDispVals()
        cMat = None
        for mat in Scene.material:
            pVals = ""
            dVals = ""
            if self.surfaces.GetValue() == mat.name:
                cMat = mat
                for val in dir(mat.surf):
                    if val.find("_") and val.find("name") and val.find("type"):
                        if str(eval("mat.surf."+val)).find('"') >= 0:
                            pVals+=' "string %s" %s'%(val[4:], eval("mat.surf."+val))
                        else: pVals+=' "float %s" %s'%(val[4:], eval("mat.surf."+val))
                for val in dir(mat.disp):
                     if val.find("_") and val.find("name") and val.find("type"):
                         if str(eval("mat.disp."+val)).find('"') >= 0:
                            dVals+=' "string %s" %s'%(val[4:], eval("mat.disp."+val))
                         else: dVals+=' "float %s" %s'%(val[4:], eval("mat.disp."+val))
        testrender = open('%s/testrender.rib'%os.getcwd(), 'w')
        testrender.write('Projection "perspective" "fov" 40\n')
        testrender.write('Format 256 256 1\n')
        testrender.write('Display "tRender.tif" "file" "rgb"\n')
        #testrender.write('Option "searchpath" "texture" ["%s"]\n'%texturesdir)
        testrender.write('Exposure 1 1.2\n')
        testrender.write('PixelSamples 1 1\n')
        testrender.write('Translate 0 0 5\n')
        testrender.write('Rotate -120 1 0 0\n')
        testrender.write('Rotate 25 0 0 1\n')
        testrender.write('WorldBegin\n')
        testrender.write('\tAttribute "visibility" "transmission" "opaque"\n')
        testrender.write('\tAttribute "visibility" "trace" 1\n')
        if self.rendermanType.GetValue() == "Pixie":
            testrender.write('\tLightSource "shadowspot" 1 "coneangle" 0.392699081699 "conedeltaangle" 0.0589048645955 "from" [0 -3 4] "to" [0 0 0] "intensity" 20.0 "lightcolor" [1.0 1.0 1.0] "shadowname" "raytrace"\n')
            testrender.write('\tLightSource "shadowspot" 1 "coneangle" 0.392699081699 "conedeltaangle" 0.0589048645955 "from" [0 3 4] "to" [0 0 0] "intensity" 20.0 "lightcolor" [1.0 1.0 1.0] "shadowname" "raytrace" \n')
        #if self.rendermanType.GetValue() == "Aqsis":
##            testrender.write('\tLightSource "spotlight" 1 "coneangle" 0.392699081699 "conedeltaangle" 0.0589048645955 "from" [0 -3 4] "to" [0 0 0] "intensity" 20.0 "lightcolor" [1.0 1.0 1.0]  \n')
##            testrender.write('\tLightSource "spotlight" 1 "coneangle" 0.392699081699 "conedeltaangle" 0.0589048645955 "from" [0 3 4] "to" [0 0 0] "intensity" 20.0 "lightcolor" [1.0 1.0 1.0] \n')
        else:
            testrender.write('\tLightSource "shadowspot" 1 "coneangle" 0.392699081699 "conedeltaangle" 0.0589048645955 "from" [0 -3 4] "to" [0 0 0] "intensity" 20.0 "lightcolor" [1.0 1.0 1.0] "shadowname" "raytrace"\n')
            testrender.write('\tLightSource "shadowspot" 1 "coneangle" 0.392699081699 "conedeltaangle" 0.0589048645955 "from" [0 3 4] "to" [0 0 0] "intensity" 20.0 "lightcolor" [1.0 1.0 1.0]  "shadowname" "raytrace"\n')
        testrender.write('\tAttributeBegin\n')
        try: testrender.write('\t\tColor [%s %s %s]\n'%(cMat.color[0]/255.0,cMat.color[1]/255.0,cMat.color[2]/255.0))
        except TypeError: self.debug.AppendText("Need to assign color to shader")
        testrender.write('\t\tAttribute "displacementbound" "string coordinatesystem" ["object"] "float sphere" [1]\n')
        testrender.write('\t\tSurface "%s" %s\n'%(cMat.surf.name,pVals))
        try: testrender.write('\t\tDisplacement "%s" %s\n'%(cMat.disp.name,dVals))
        except AttributeError: pass
        testrender.write('\t\tSphere 1 -1 1 360\n')
	testrender.write('\tAttributeEnd\n')
        testrender.write('\tAttributeBegin\n')
	testrender.write('\t\tSurface "matte"\n')
        testrender.write('\t\tPointsPolygons [4 ]  [0 3 2 1 ]\n')
        testrender.write('\t\t\t"P" [10.0 10.0 -1.0 10.0 -10.0 -1.0 -10.0 -10.0 -1.0 -10.0 10.0 -1.0 ]\n')
        testrender.write('\tAttributeEnd\n')
        testrender.write('WorldEnd\n')
        testrender.flush()
        testrender.close()
        self.bTestRender.SetLabel("Please Wait")
        self.debug.AppendText("\tRendering to tRender.tif\n")
        exe = self.rendermanExe.GetValue()
        os.popen('%s "%s"'%(exe, '%s\\testrender.rib'%os.getcwd()))
        self.debug.AppendText("Render complete\n")
        self.testImage.SetBitmap(readImage('tRender.tif'))
        self.bTestRender.SetLabel("Test Render")
## Object Editor
    def redrawObjPanel(self, event):
        global treeItem, treeParent
        item = event.GetItem()
        parent = self.objTree.GetItemParent(item)
        treeItem =  self.objTree.GetItemText(item)
        treeParent = parent
        if self.objTree.GetItemText(item) != "Scene":
            if self.objTree.GetItemText(parent) == "Meshes":
                mName = self.objTree.GetItemText(item)
                self.oEditPanel.DestroyChildren()
                self.geoPanel = self.res.LoadPanel(self.oEditPanel, "geometry")
                self.oPanel.GetSizer().Fit(self.oEditPanel)
                ## OBJ Panel
                self.objShaders         = wx.xrc.XRCCTRL(self.geoPanel, "objShaders")
                self.meshType           = wx.xrc.XRCCTRL(self.geoPanel, "meshType")
                self.reloadObjShaders   = wx.xrc.XRCCTRL(self.geoPanel, "reloadObjShaders")
                self.lightLinkChoice    = wx.xrc.XRCCTRL(self.geoPanel, "lightLinkChoice")
                self.lightLinkToggle    = wx.xrc.XRCCTRL(self.geoPanel, "lightLinkToggle")
                self.attributeButton    = wx.xrc.XRCCTRL(self.geoPanel, "attributeButton")
                ## Events
                wx.EVT_COMBOBOX(self, wx.xrc.XRCID("objShaders"),self.assignSurface)
                wx.EVT_COMBOBOX(self, wx.xrc.XRCID("meshType"),self.assignMeshType)
                wx.EVT_BUTTON(self, wx.xrc.XRCID("reloadObjShaders"),self.reloadObjSurfacesEvent)
                wx.EVT_BUTTON(self, wx.xrc.XRCID("attributeButton"),self.attWindow)
                wx.EVT_CHOICE(self, wx.xrc.XRCID("lightLinkToggle"),self.assignLightLinks)
                
                for mesh in Scene.meshes:
                    if mesh.name == treeItem:
                        if mesh.mat:
                            self.objShaders.SetValue(mesh.mat)
                        if mesh.type:
                            self.meshType.SetValue(mesh.type)
                for mat in Scene.material:
                    self.objShaders.Append(mat.name)
                    self.objShaders.Enable()
                for light in Scene.lights:
                    self.lightLinkChoice.Append(light.name)
            if self.objTree.GetItemText(parent) == "Lights":
                self.oEditPanel.DestroyChildren()
                self.lightPanel = self.res.LoadPanel(self.oEditPanel, "light")
                self.oPanel.GetSizer().Fit(self.oEditPanel)
                self.lightShaders   = wx.xrc.XRCCTRL(self.lightPanel, "lightSurface")
                self.reloadLights   = wx.xrc.XRCCTRL(self.lightPanel, "reloadLights")
                self.editLight   = wx.xrc.XRCCTRL(self.lightPanel, "editLight")
                self.lightPropPanel = wx.xrc.XRCCTRL(self.lightPanel, "lightProps")
                wx.EVT_CHOICE(self, wx.xrc.XRCID("lightSurface"),self.assignLightSurface)
                wx.EVT_BUTTON(self, wx.xrc.XRCID("reloadLights"),self.reloadLightSurface)
                wx.EVT_BUTTON(self, wx.xrc.XRCID("editLight"),self.assignLightSurface)
                # Preload if values exsits
                for light in lightIndex:
                    self.lightShaders.Append(light.name)
                for light in Scene.lights:
                    if light.name == treeItem:
                        try:
                            #has shader here!!!
                            self.lightShaders.Append(light.shader.name)
                            self.lightShaders.SetSelection(0)
                        except AttributeError: pass
            if self.objTree.GetItemText(parent) == "Curves":
                self.oEditPanel.DestroyChildren()
                self.lightPanel = self.res.LoadPanel(self.oEditPanel, "curve")
                self.oPanel.GetSizer().Fit(self.oEditPanel)
        if self.objTree.GetItemText(item) == "Scene":
            self.oEditPanel.DestroyChildren()
            self.scenePanel = self.res.LoadPanel(self.oEditPanel, "scene")
            self.oPanel.GetSizer().Fit(self.oEditPanel)
            wx.EVT_BUTTON(self, wx.xrc.XRCID("optionButton"),self.optionButton)
            wx.EVT_BUTTON(self, wx.xrc.XRCID("attributeButton"),self.attWindow)
            
    def attWindow(self,event):
        if Scene.renderman == "Pixie":
            att = pixie.attributes(self.frame)
            if att.dlg.ShowModal() == wx.ID_OK:
                mesh = searchMesh(treeItem)
                mesh.attributes = att.getAttributes()
    def optionButton(self,event):
        if Scene.renderman == "Pixie":
            options = pixie.options(self.frame)
            if options.dlg.ShowModal() == wx.ID_OK:
                Scene.options = options.getAttributes()
                
    def changeLampName(self, lampName):
        for i,light in enumerate(Scene.lights):
            if light.name == lampName:
                lampName = i
        return lampName
    def removeObject(self,event):
        global treeItem, treeParent
        if  treeItem != "Meshes" or treeItem != "Lights" or treeItem != "Scene" or treeItem != "Curves" or treeItem != "Nurbs":
            parent = self.objTree.GetItemText(treeParent)
            if parent != "Scene":
                item        = searchScene(treeItem,parent.lower())
                itemScene   = eval("Scene.%s"%parent.lower())
                itemScene.remove(item)
                self.objTree.Delete(self.objTree.GetSelection())
                    
    def assignLightLinks(self, event):
        mesh = searchMesh(treeItem)
        lampName = self.lightLinkChoice.GetLabel()
        lampOption = event.GetString()
        lampName = self.changeLampName(lampName)
            
        try:
            add = True
            for link in mesh.lightLinks:
                print "has link"
                if link[0] == lampName:
                    print "link exsits"
                    link[1] = lampOption
                    add = False
            if add:
                print "adding link"
                mesh.lightLinks.append([lampName, lampOption])
        except:
            mesh.lightLinks = []
            mesh.lightLinks.append([lampName, lampOption])
            
    def reloadObjSurfacesEvent(self, event):
        self.objShaders.Clear()
        for mat in Scene.material:
            self.objShaders.Append(mat.name)
            self.objShaders.Enable()
    def reloadLightSurface(self, event):
        global lightIndex
        self.lightShaders.Clear()
        lightIndex= []
        self.appendSL()
        for light in lightIndex:
            self.lightShaders.Append(light.name)
            self.lightShaders.Enable()

    def assignSurface(self, event):
        global treeItem
        
        for mesh in Scene.meshes:
            if mesh.name == treeItem:
                mesh.mat = self.objShaders.GetValue()
    def assignLightSurface(self, event):
        global tregeItem
        lightItem = None
        hasShader = False
        for light in Scene.lights:
            if light.name == treeItem:
                # Assign props to light class
                lightItem = light
                sameShader = False
                try:
                    hasShader = True
                except AttributeError:
                    #print "No shader"
                    light.shader = cName()
                    light.shader.name = self.lightShaders.GetLabel()

        for light in lightIndex:
            self.lightShaders.Append(light.name)
            if hasShader:
                #print "Has something"
                try:
                    if light.name == lightItem.shader.name:
                        print "Loading from wxsisting stuff"
                        print dir(lightItem.shader)
                        self.lightPropPanel.DestroyChildren()
                        self.lightScrollPanel = sManClass.scrollPanel(self.lightPropPanel)
                        vbox = self.lightScrollPanel.GetSizer()
                        for prop in dir(lightItem.shader):
                            if prop.find("_") and prop.find("name") and prop.find("type"):
                                    self.valSizer = wx.BoxSizer(wx.HORIZONTAL)
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, prop[4:]))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, eval("lightItem.shader."+prop)))
                                    vbox.Add(self.valSizer)
                        # set light props to lightshader in Scene.lights
                        self.setLightShader = wx.Button(self.lightScrollPanel, 20, "Set", (23, 80))
                        vbox.Add(self.setLightShader)
                        self.lightScrollPanel.Bind(wx.EVT_BUTTON, self.copyLight, self.setLightShader)
                        self.lightScrollPanel.SetAutoLayout(1)
                        self.lightScrollPanel.SetupScrolling()
                        self.lightPropPanel.GetSizer().Add(self.lightScrollPanel)
                        self.lightPanel.GetSizer().Fit(self.lightPanel)
                        self.notebook.Fit()
                except AttributeError:
                    hasShader = False
            if hasShader == False:
                if light.name == self.lightShaders.GetLabel():
                    global lightItems
                    print "Loading light props from export file"
                    self.lightPropPanel.DestroyChildren()
                    self.lightScrollPanel = sManClass.scrollPanel(self.lightPropPanel)
                    vbox = self.lightScrollPanel.GetSizer()
                    lightItems = light
                    light = self.parseSL(lightItems.name)
                    for prop in dir(light):
                        if prop.find("_") and prop.find("name") and prop.find("type"):
                                self.valSizer = wx.BoxSizer(wx.HORIZONTAL)
                                print prop
                                if prop == "parafrom" or  prop == "from":
                                    (x,y,z) = lightItem.lock[0]
                                    (x,y,z) = round(x,2),round(y,2),round(z,2)
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, "from"))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, "[%s %s %s]"%(x,y,z)))
                                elif prop == "parato":
                                    (x,y,z) = lightItem.look[0]
                                    (x,y,z) = round(x,2),round(y,2),round(z,2)
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, "to"))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, "[%s %s %s]"%(x,y,z)))
                                elif prop == "parablur":
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, "blur"))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, "%s"%lightItem.blur))
                                elif prop == "parashadowname":
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, "shadowname"))
                                    self.lampRenderType = wx.ComboBox(self.lightScrollPanel, -1, "raytrace",(90, 50), (95, -1), ['raytrace','shadow buffer'])
                                    self.valSizer.Add(self.lampRenderType)
                                    self.lightScrollPanel.Bind(wx.EVT_COMBOBOX, self.setLightRenderType, self.lampRenderType)
                                    #self.lightPropPanel.Bind(wx.EVT_COMBOBOX, self.lampRenderType, self.setLightRenderType)
                                    #self.valSizer.Add(wx.TextCtrl(self.lightPropPanel, -1, "%s.tx-%s"%(lightItem.name,lightItem.buff)))
                                elif prop == "paraconeangle":
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, "coneangle"))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, "%s"%lightItem.coneangle))
                                elif prop == "paraconedeltaangle":
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, "conedeltaangle"))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, "%s"%lightItem.conedeltaangle))
                                elif prop.find("sample") >= 0 or prop.find("Sample") >= 0:
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, prop[4:]))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, str(lightItem.samples)))
                                elif prop == "paraintensity":
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, prop[4:]))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, str(lightItem.energy)))
                                elif prop.find("color") >= 0 or prop.find("Color") >= 0:
                                    (r,g,b) = lightItem.color
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, prop[4:]))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, "[%s %s %s]"%(r,g,b)))
                                else:
                                    self.valSizer.Add(wx.StaticText(self.lightScrollPanel, -1, prop[4:]))
                                    self.valSizer.Add(wx.TextCtrl(self.lightScrollPanel, -1, str(eval("light."+prop))))
                                vbox.Add(self.valSizer)
                    # set light props to lightshader in Scene.lights
                    self.setLightShader = wx.Button(self.lightScrollPanel, 20, "Set", (23, 80))
                    vbox.Add(self.setLightShader)
                    self.lightScrollPanel.Bind(wx.EVT_BUTTON, self.copyLight, self.setLightShader)
                    self.lightScrollPanel.SetAutoLayout(1)
                    self.lightScrollPanel.SetupScrolling()
                    self.lightPropPanel.GetSizer().Add(self.lightScrollPanel)
                    self.lightPanel.GetSizer().Fit(self.lightPanel)
                    self.notebook.Fit()
                    

    def setLightRenderType(self, event):
        global lightItems
        #print lightItems
        if self.lampRenderType.GetValue() == "raytrace":
            lightItems.shadowname = "raytrace"
        else:
            lightItems.shadowname = "shadow buffer"

    def copyLight(self, event):
        global treeItem
        lightShader = cName()
        children = self.lightPropPanel.GetChildren()[0].GetChildren()
        for i,child in enumerate(children):
            print child.GetName()
            if child.GetName() == "staticText":
                if child.GetLabel().find("Set") == -1:
                    lightShader.name = self.lightShaders.GetLabel()
                    exec("lightShader.%s = '%s'"%('para'+child.GetLabel(),children[i+1].GetValue()))
        for light in Scene.lights:
            if light.name == treeItem:
                print "assigning light to lamp"
                light.shader = lightShader
                print treeItem,dir(light.shader)
    def assignMeshType(self, event):
        global treeItem
        
        for mesh in Scene.meshes:
            if mesh.name == treeItem:
                mesh.type = self.meshType.GetValue()
## Load and Save Stuff
    def newsMan(self):
        Scene = None
    def loadScene(self):
        self.treeCamera = self.objTree.AppendItem(self.treeRoot, "Camera")
        for lamp in Scene.lights:
            self.objTree.AppendItem(self.treeLight, lamp.name)
        for mesh in Scene.meshes:
            self.objTree.AppendItem(self.treeMesh, mesh.name)
        try:
            for curve in Scene.curves:
                self.objTree.AppendItem(self.treeCurve, curve.name)             
        except: pass
        for mat in Scene.material:
            self.surfaces.Append(mat.name)
            try:
                if Scene.renderman == "Pixie":
                    file = open(pixiePath+"//shaders//"+mat.surf.name+".sdr", "r")
                if Scene.renderman == "Aqsis":
                    file = open(aqsisPath+"//shaders//"+mat.surf.name+".slx", "r")
                if Scene.renderman == "Aqsis":
                    file = open(delightPath+"//shaders//"+mat.surf.name+".sdl", "r")
            except: pass
            self.readSL(file)
            self.showSurface()
        if Scene.output == "file" or Scene.output == "File":
            self.toggleFile.SetValue(True)
            self.toggleBuffer.SetValue(False)
        else:
            self.toggleBuffer.SetValue(True)
            self.toggleFile.SetValue(False)
        self.rezX.SetValue(str(Scene.resolution[0]))
        self.rezY.SetValue(str(Scene.resolution[1]))
        try: self.rendermanType.SetValue(Scene.renderman)
        except: Scene.renderman = self.rendermanType.GetValue()
                
    def loadBlendFile(self, event):
        wildcard = "Blender file (*.blend)|*.blend|"     \
                   "All files (*.*)|*.*"
        dlg = wx.FileDialog(
            self.frame, message="Choose a file", defaultDir=os.getcwd(), 
            defaultFile="", wildcard=wildcard, style=wx.OPEN | wx.MULTIPLE | wx.CHANGE_DIR
            )
        if dlg.ShowModal() == wx.ID_OK:
            paths = dlg.GetPaths()
        dlg.Destroy()
    def loadsMan(self,event):
        global Scene
        wildcard = "S&W GUI file (*.sman)|*.sman|"     \
                   "All files (*.*)|*.*"
        dlg = wx.FileDialog(
            self.frame, message="Choose a file", defaultDir=os.getcwd(), 
            defaultFile="", wildcard=wildcard, style=wx.OPEN | wx.MULTIPLE | wx.CHANGE_DIR
            )
        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            file = open(path,"rb")
            Scene = pickle.loads(zlib.decompress(file.read()))
            self.loadScene()
        dlg.Destroy()
    def savesMan(self,event):
        wildcard = "S&W GUI file (*.sman)|*.sman|"     \
                   "All files (*.*)|*.*"
        dlg = wx.FileDialog(
            self.frame, message="Save file as ...", defaultDir=os.getcwd(), 
            defaultFile="", wildcard=wildcard, style=wx.SAVE)
        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            file = open(path,"w")
            file.write(zlib.compress(pickle.dumps(Scene),zlib.Z_BEST_COMPRESSION))
            self.debug.AppendText('File saved')
        dlg.Destroy()
################################
    def aboutSoftware(self, event):
        dlg = wx.MessageDialog(self.frame, 'Created by S|W \n www.sutabi.tk',
                               'About',
                               wx.OK | wx.ICON_INFORMATION
                               )
        dlg.ShowModal()
        dlg.Destroy()
    def renderLamp(self,lamp):
        lampDN = '%s/%s/shadows/%s'%(os.getcwd(),self.folderName.GetValue(),lamp.name)
        try:
            file = open('%s/%s/shadows/%s'%(os.getcwd(),self.folderName.GetValue(),lamp.name), 'w')
        except IOError:
            os.makedirs(self.folderName.GetValue()+'/shadows/')
            file = open('%s/%s/shadows/%s'%(os.getcwd(),self.folderName.GetValue(),lamp.name), 'w')
        file.write('FrameBegin 0\n')
        file.write('Projection "perspective" "fov" 75.0\n')
        file.write('PixelSamples 1 1\n')
        file.write('Hider "hidden" "depthfilter" "midpoint"\n')
        file.write('PixelFilter "box" 1 1\n')
        file.write('Hider "hidden" "jitter" [0]\n')
        file.write(lamp.trans[0]+'\n') #Transform [1.0 8.71751915099e-009 -4.67711336327e-009 0.0 -2.43552267243e-009 0.675158023834 0.737673044205 0.0 -9.58847046206e-009 0.737673103809 -0.675158083439 0.0 4.2764060737e-008 1.5878688097 12.1028366089 1.0]
        file.write('Format 1024 1024 1\n')
        file.write('Display "%s.tif" "zfile" "z"\n'%lampDN)
        file.write('ShadingRate 1\n')
        file.write('WorldBegin\n')
        for mesh in Scene.meshes:
            file.write(mesh.trans[0])
            file.write('\t\tReadArchive "%s//mesh//%s.rib"\n'%(self.folderName.GetValue(),mesh.name))
        file.write('WorldEnd\n')
        file.write('FrameEnd\n')
        file.flush()
        file.close()
        lampTexture = '%s//shadows//%s'%(self.folderName.GetValue(),lamp.name)
        render = os.popen('%s "%s"'%(self.rendermanExe.GetValue(), '%s//shadows//%s'%(self.folderName.GetValue(),lamp.name)))
        print render.read()
        render = os.popen('%s "%s" "%s"'%(self.textureExe.GetValue(), lampTexture+'.tif',lampTexture+'.tx'))
        print render.read()

    def exportRib(self,event):
        export  = 1
        endError = ""
        try:
            Scene.camera
        except AttributeError:
            self.debug.AppendText("No Camera set, unable to Xport. Add a camera in the Object Editor\n")
            export = 0
        try:
            file = open('%s/%s/%s'%(os.getcwd(),self.folderName.GetValue(),self.ribName.GetValue()), 'w')
        except IOError:
            os.makedirs(self.folderName.GetValue())
            file = open('%s/%s/%s'%(os.getcwd(),self.folderName.GetValue(),self.ribName.GetValue()), 'w')
        if export:
            self.debug.AppendText("Xporting...\n")
            file.write('FrameBegin 1\n')
            try:
                for hider in Scene.hider:
                    file.write('%s %s\n'%(hider, Scene.hider[hider]))
            except: pass
            texFolder = self.folderName.GetValue()+'//textures//'
            shaFolder = self.folderName.GetValue()+'//shadows//'
            file.write('Option "searchpath" "texture" ["%s:%s"]\n'%(texFolder,shaFolder))
            file.write('Projection "perspective" "fov" [%s]\n'% Scene.camera.lens[0])
            file.write('Format %s %s 1\n'%(Scene.resolution[0],Scene.resolution[1]))
            file.write('Clipping %s %s\n'%(Scene.camera.start[0],Scene.camera.end[0]))
            file.write('PixelSamples %s %s\n'%(str(Scene.pixelSamples).split()[0],str(Scene.pixelSamples).split()[0]))
            file.write('Exposure 1.0 1.0\n')
            file.write('ShadingRate %s\n'% str(Scene.shaderRate).split()[0])
            file.write('Option "statistics" "integer endofframe" [%s]\n'% self.debugLevel.GetValue())
            file.write('%s'% Scene.camera.trans[0])
            ## DOF
            if self.DOF.GetValue():
                file.write('DepthOfField %s %s %s'%(self.dofStop.GetValue(),self.dofLength.GetValue(),self.dofDist.GetValue()))
            
            if self.toggleFile.GetValue() and self.toggleBuffer.GetValue():
                file.write('Display "%s.tif" "file" "%s"\n'%(self.imageName.GetValue(), self.renderType.GetValue()))
                file.write('Display "+%s.tif" "framebuffer" "%s"\n'%(self.imageName.GetValue(), self.renderType.GetValue()))
            else:
                file.write('Display "%s.tif" "%s" "%s"\n'%(self.imageName.GetValue(), Scene.output, self.renderType.GetValue()))
            file.write('WorldBegin\n')
            file.write('\tAttribute "visibility" "transmission" "opaque"\n')
            file.write('\tAttribute "visibility" "trace" 1\n')
            ### -- Mesdh to file -- ###
            meshFolder = self.folderName.GetValue()+'//mesh//'
            try: os.makedirs(meshFolder)
            except OSError: pass
            for mesh in Scene.meshes:
                mfile = open('%s/%s/%s'%(os.getcwd(),meshFolder,mesh.name+".rib"), 'w')
                if mesh.type == "SubDivSurf":
                    out = ""
                    out += 'SubdivisionMesh "catmull-clark" %s\n%s\n'%(arrayOut(mesh.geo.length),arrayOut(mesh.geo.nvert))
                    ### FIX ME, what if there are no creases man!!! Get working lazy dumbass!!!
                    try:
                        if mesh.crease[1]:
                            out += '["crease" "interpolateboundary"] %s \n"P" '%str(mesh.geo.crease).replace(","," ")[1:-1]
                        else:
                            out += '["interpolateboundary"] [0 0] [] [] "P" '
                    except:
                        out += '["interpolateboundary"] [0 0] [] [] "P" '
                    out += arrayOut(mesh.geo.vert)+'\n'
                    mfile.write(out)
                if mesh.type == "PointPolygons":
                    out = ""
                    out += "PointsPolygons %s %s\n"%(arrayOut(mesh.geo.length),arrayOut(mesh.geo.nvert))
                    out += '"P" '+arrayOut(mesh.geo.vert)+'\n'
                    out += '"N" '+arrayOut(mesh.geo.normal)+'\n'
                    mfile.write(out)
                mfile.flush()
                mfile.close()
                
            ### --Lights -- ###
            for light in Scene.lights:
                self.renderLamp(light)
                lVals = ""
                try:
                    for val in dir(light.shader):
                        if val.find("__") and  val != "name" and  val != "type":
                                if val == "parashadowname":
                                    if eval("light.shader."+val) == "raytrace":
                                        lVals += '"shadowname" "%s"'%eval("light.shader."+val)
                                    else:
                                        lVals += '"shadowname" ["%s"]'%(light.name+'.tx')
                                else:
                                    lVals += '"%s" %s ' %(val[4:], eval("light.shader."+val))
                    file.write('\tLightSource "%s" %s %s \n'% (light.shader.name,self.changeLampName(light.name),lVals))
                except AttributeError:
                    endError += "Error: No light shader set to lamp, don't expect to render correctly\n"
            ###################
            ### --Meshes -- ###
            # -- Write meshes to mesh files
            meshFolder = self.folderName.GetValue()+'//mesh//'
            for mesh in Scene.meshes:
                # -- Write other mesh stuff to rib
                file.write('\tAttributeBegin\n')
                file.write('\t\tAttribute "displacementbound" "string coordinatesystem" ["object"] "float sphere" [1]\n')
                file.write('\t\tAttribute "identifier" "name" "%s"\n'%mesh.name)
                try:
                    for att in mesh.attributes:
                       file.write('\t\tAttribute %s %s\n'%(att, mesh.attributes[att])) 
                except AttributeError: pass
                file.write('%s'%mesh.trans[0])
                ##- Light Links
                try:
                    for link in mesh.lightLinks:
                        if link[1] == "On":
                            file.write('\t\tIlluminate %s 1\n'%link[0])
                        else:
                            file.write('\t\tIlluminate %s 0\n'%link[0])
                except: pass
                ## -- Convert Texture
                textureFolder = self.folderName.GetValue()+'//textures//'
                try:
                    import Image
                    name = mesh.image.split("\\")[-1].split(".")[0]
                    nPlace = mesh.image.split(".")[0]
                    im = Image.open(mesh.image)
                    print nPlace
                    im.save(textureFolder+name+".tif", "TIFF")         
                    mesh.image = textureFolder+name+".tif"
                except: pass
                
                imageDirName = ""
                try: os.makedirs(textureFolder)
                except OSError: pass
                try:
                    iName = mesh.image.split("//")[-1].split(".")[0]
                    imageDirName = iName+'.tx'
                    print mesh.image,imageDirName
                    render = os.popen('%s "%s" "%s"'%(self.textureExe.GetValue(), mesh.image,imageDirName))
                    print render.read()
                except: pass
                ##- Write shader and displacement
                if mesh.mat:
                    surf = ""
                    disp = ""
                    for mat in Scene.material:
                        if mesh.mat == mat.name:
                            try: (r,g,b) = mat.color
                            except: r,g,b = (1,1,1)
                            file.write('\t\tColor [%s %s %s]\n'%(r,g,b))
                            for val in dir(mat.surf):
                                if val.find("__") and val.find("name") and val.find("type"):
                                    if val == "paratexname" or val == "paratexturename":
                                        print imageDirName
                                        surf +='"%s" "%s" '%(val[4:], imageDirName)#eval("mat.surf."+val))
                                    else: surf +='"%s" %s '%(val[4:], eval("mat.surf."+val))
                            file.write('\t\tSurface "%s" %s\n'%(mat.surf.name,surf))
                            for val in dir(mat.disp):
                                if val.find("__") and val.find("name") and val.find("type"):
                                    disp +='"%s" %s '%(val[4:], eval("mat.disp."+val))
                            try: file.write('\t\tDisplacement "%s" %s\n'%(mat.disp.name,disp))
                            except AttributeError: pass
                file.write('\t\tReadArchive "%s//mesh//%s.rib"\n'%(self.folderName.GetValue(),mesh.name))
                file.write('\tAttributeEnd\n')
            ###################
            ### --Curves-- ###
            try:
                file.write('\t\tColor [1 1 1]\n')
                for curve in Scene.curves:
                    file.write('\tAttributeBegin\n')
                    file.write('%s'%curve.trans[0])
                    file.write('\t\t%s\n'%curve.data)
                    file.write('\tAttributeEnd\n')
            except: pass
            
            file.write('WorldEnd\n')
            file.write('FrameEnd\n')
            file.flush()
            file.close()
            self.debug.AppendText("Xport complete\n")
            if self.toggleRender.GetValue():
                self.debug.AppendText("Rendering\n")
                render = os.popen('%s "%s"'%(self.rendermanExe.GetValue(), '%s//%s'%(self.folderName.GetValue(),self.ribName.GetValue())))
                for err in render.read().split("\r"):
                    if err:
                        endError += err
                self.debug.AppendText("Render Complete\n")
                if self.toggleFile.GetValue():
                    self.debug.AppendText("Image can be found at: %s\%s.tif\n" %(os.getcwd(),self.imageName.GetValue()))
            else: pass
            self.debug.AppendText(endError)

def main():
    app = MyApp(0)
    app.MainLoop()

if __name__ == '__main__':
    main()
